import { Typography, Card, CardBody, CardFooter, Button } from "@material-tailwind/react";
import ReactWebsocket from "@/api/websocket"
import React, { useCallback,useState } from 'react';


import {
  Dialog,
  DialogHeader,
  DialogBody,
  DialogFooter,
  Input,
} from "@material-tailwind/react";

import { useSelector, useDispatch } from 'react-redux'
import { decrement, increment,wolupdata,delitem } from '@/store/reducers/wolSlice'
import toast, { Toaster } from 'react-hot-toast';

export default function WolItem(props) {
  const { id, mac, name, updata } = props;
  const socket = new ReactWebsocket()
  const dispatch = useDispatch()
  function isMACAddress(strMac) {
    var reg = /^([0-9a-fA-F]{2})(([/\s:][0-9a-fA-F]{2}){5})$/;
    if (reg.test(strMac)) {
      return true;
    } else {
      return false;
    }
  }
  const handleClickSendMessage = useCallback(() => {
    if (!isMACAddress(mac)) {
      console.log("mac输入错误");
      toast.error('mac错误请按照标准填写')
      return;
    }
    socket.sendMessage('start', {mac}, function () { toast.success('已经发送') })
  }, mac);
  const deleteItem = useCallback(() => {
    // socket.sendMessage('del', {id}, function () { updata() })
    socket.sendMessage('del', {id}, function () { dispatch(delitem(id));socket.sendMessage('getall', '', function (eve) { dispatch(wolupdata(eve.data[0]));handleOpen() }) })
  }, []);

  const [open, setOpen] = React.useState(false);

  const handleOpen = () => setOpen(!open);

  const [NameValue, setNameValue] = useState(name);
  const [MacValue, setMacValue] = useState(mac);

  const openEdi = useCallback(() => {
    
    
  }, []);
    const EdiItem = useCallback(() => {
    socket.sendMessage('edi', {id:id,'name':NameValue,'mac':MacValue}, function () { socket.sendMessage('getall', '', function (eve) { dispatch(wolupdata(eve.data[0]));handleOpen() }) })
    
  });
  return (
    <>
    <div className="p-6">
      <Card className="mt-6 w-96 border border-blue-gray-50 py-4 px-5 shadow-xl shadow-transparent transition-all hover:-translate-y-4 hover:border-blue-gray-100/60 hover:shadow-blue-gray-900/5">
        <CardBody>
          <Typography variant="h5" color="blue-gray" className="mb-2">
            {name}
          </Typography>
          <Typography>
            MAC:{mac}
          </Typography>
        </CardBody>
        <CardFooter className="pt-0 ">
          <Button className="w-50" onClick={handleClickSendMessage}>发送wol数据</Button>
          <Button className="w-20 mx-1 " onClick={handleOpen} color="amber">编辑</Button>
          <Button className="w-20" onClick={deleteItem} color="amber">删除</Button>
        </CardFooter>
      </Card>

      <Dialog size="xs" open={open} handler={handleOpen}>
                <DialogHeader>编辑:{name}</DialogHeader>
                <DialogBody divider>
                    <div className="flex w-100 flex-col items-end gap-6">
                        <Input size="md" label="别名" value={NameValue} onChange={e => {setNameValue(e.target.value);}} />
                        <Input size="md" label="mac地址" value={MacValue} 	onChange={e => {setMacValue(e.target.value);}} />
                    </div>
                </DialogBody>
                <DialogFooter>
                    <Button
                        variant="text"
                        color="red"
                        onClick={handleOpen}
                        className="mr-1"
                    >
                        <span>取消</span>
                    </Button>
                    <Button variant="gradient" color="green" onClick={EdiItem}>
                        <span>确认</span>
                    </Button>
                </DialogFooter>
            </Dialog>
    </div>
    </>
  );
}
